



#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
       variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    source Global.tcl

   proc  show_variables {} {
       variable JS

    upvar #0 AGATADigitizerAccessServer_ConfigFile ConfigFile
    upvar #0 AGATADigitizerAccessServer_NumDigitizer NumDigitizer


       append JS "alert(\"ConfigFile=  [set ConfigFile]; NumDigitizer= [set NumDigitizer]\");"
   }

    proc update_config {} {
        variable cgidata
        upvar #0 AGATADigitizerAccessServer_MaxDigitizer MaxDigitizer
        upvar #0 AGATADigitizerAccessServer_XportList XportList

        for {set i 2} {$i < [llength $cgidata]} {incr i} {

            set name [lindex $cgidata $i]
            incr i
            set value [lindex $cgidata $i]

            switch -glob $name {

               ADDR*  {set Addr([string range $name 4 end]) $value}
               PORT*  {set Port([string range $name 4 end]) $value}
               ACT*   {set Active([string range $name 3 end]) $value}
            }
        }

        catch {unset XportList}
        for {set i 0} {$i < $MaxDigitizer} {incr i} {
            if {[info exists Active($i)] && [set Active($i)] == 1} {set XportList($i) [set Addr($i)]:[set Port($i)]}
        }
            
        return 0
   }

   proc save_config {} {
       variable JS
        upvar #0 AGATADigitizerAccessServer_MaxDigitizer MaxDigitizer
        upvar #0 AGATADigitizerAccessServer_ConfigFile ConfigFile
        upvar #0 AGATADigitizerAccessServer_XportList XportList

        set z [catch {open $ConfigFile w} file]
        if {$z != 0} {
            append JS "alert(\"Unable to access $ConfigFile\");"
            InsertLog "[set file]"
            return
        }

        for {set i 0} {$i < $MaxDigitizer} {incr i} {
            if {[info exists XportList($i)]} {puts $file "set XportList($i) [set XportList($i)]"}
        }

        close $file

        append JS "alert(\"$ConfigFile updated\");"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {

           switch -glob [lindex $cgidata 1] {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                UPDATE   {update_config}
                SAVE     {save_config}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

