

#   Package for interfacing to the MEIS EPICS system

set PACKAGE EPICSClientAccess
set VERSION 1.0

global tcl_platform
global env

switch $tcl_platform(os) {
   "Windows NT" {
       package ifneeded $PACKAGE $VERSION  \
          [load [file join $env(MIDASBASE) MIDASpackages $PACKAGE$VERSION Win [set PACKAGE].dll]]
   }
   Linux {
       package ifneeded $PACKAGE $VERSION  \
          [load [file join $env(MIDASBASE) MIDASpackages $PACKAGE$VERSION Linux lib[set PACKAGE].so]]
   }
   default {puts "unknown or unsupported os - $tcl_platform(os)"}
}

